import { DatabaseMigrationServiceClient } from "./DatabaseMigrationServiceClient";
import { AddTagsToResourceInput } from "./types/AddTagsToResourceInput";
import { AddTagsToResourceOutput } from "./types/AddTagsToResourceOutput";
import { ApplyPendingMaintenanceActionInput } from "./types/ApplyPendingMaintenanceActionInput";
import { ApplyPendingMaintenanceActionOutput } from "./types/ApplyPendingMaintenanceActionOutput";
import { CreateEndpointInput } from "./types/CreateEndpointInput";
import { CreateEndpointOutput } from "./types/CreateEndpointOutput";
import { CreateEventSubscriptionInput } from "./types/CreateEventSubscriptionInput";
import { CreateEventSubscriptionOutput } from "./types/CreateEventSubscriptionOutput";
import { CreateReplicationInstanceInput } from "./types/CreateReplicationInstanceInput";
import { CreateReplicationInstanceOutput } from "./types/CreateReplicationInstanceOutput";
import { CreateReplicationSubnetGroupInput } from "./types/CreateReplicationSubnetGroupInput";
import { CreateReplicationSubnetGroupOutput } from "./types/CreateReplicationSubnetGroupOutput";
import { CreateReplicationTaskInput } from "./types/CreateReplicationTaskInput";
import { CreateReplicationTaskOutput } from "./types/CreateReplicationTaskOutput";
import { DeleteCertificateInput } from "./types/DeleteCertificateInput";
import { DeleteCertificateOutput } from "./types/DeleteCertificateOutput";
import { DeleteEndpointInput } from "./types/DeleteEndpointInput";
import { DeleteEndpointOutput } from "./types/DeleteEndpointOutput";
import { DeleteEventSubscriptionInput } from "./types/DeleteEventSubscriptionInput";
import { DeleteEventSubscriptionOutput } from "./types/DeleteEventSubscriptionOutput";
import { DeleteReplicationInstanceInput } from "./types/DeleteReplicationInstanceInput";
import { DeleteReplicationInstanceOutput } from "./types/DeleteReplicationInstanceOutput";
import { DeleteReplicationSubnetGroupInput } from "./types/DeleteReplicationSubnetGroupInput";
import { DeleteReplicationSubnetGroupOutput } from "./types/DeleteReplicationSubnetGroupOutput";
import { DeleteReplicationTaskInput } from "./types/DeleteReplicationTaskInput";
import { DeleteReplicationTaskOutput } from "./types/DeleteReplicationTaskOutput";
import { DescribeAccountAttributesInput } from "./types/DescribeAccountAttributesInput";
import { DescribeAccountAttributesOutput } from "./types/DescribeAccountAttributesOutput";
import { DescribeCertificatesInput } from "./types/DescribeCertificatesInput";
import { DescribeCertificatesOutput } from "./types/DescribeCertificatesOutput";
import { DescribeConnectionsInput } from "./types/DescribeConnectionsInput";
import { DescribeConnectionsOutput } from "./types/DescribeConnectionsOutput";
import { DescribeEndpointTypesInput } from "./types/DescribeEndpointTypesInput";
import { DescribeEndpointTypesOutput } from "./types/DescribeEndpointTypesOutput";
import { DescribeEndpointsInput } from "./types/DescribeEndpointsInput";
import { DescribeEndpointsOutput } from "./types/DescribeEndpointsOutput";
import { DescribeEventCategoriesInput } from "./types/DescribeEventCategoriesInput";
import { DescribeEventCategoriesOutput } from "./types/DescribeEventCategoriesOutput";
import { DescribeEventSubscriptionsInput } from "./types/DescribeEventSubscriptionsInput";
import { DescribeEventSubscriptionsOutput } from "./types/DescribeEventSubscriptionsOutput";
import { DescribeEventsInput } from "./types/DescribeEventsInput";
import { DescribeEventsOutput } from "./types/DescribeEventsOutput";
import { DescribeOrderableReplicationInstancesInput } from "./types/DescribeOrderableReplicationInstancesInput";
import { DescribeOrderableReplicationInstancesOutput } from "./types/DescribeOrderableReplicationInstancesOutput";
import { DescribePendingMaintenanceActionsInput } from "./types/DescribePendingMaintenanceActionsInput";
import { DescribePendingMaintenanceActionsOutput } from "./types/DescribePendingMaintenanceActionsOutput";
import { DescribeRefreshSchemasStatusInput } from "./types/DescribeRefreshSchemasStatusInput";
import { DescribeRefreshSchemasStatusOutput } from "./types/DescribeRefreshSchemasStatusOutput";
import { DescribeReplicationInstanceTaskLogsInput } from "./types/DescribeReplicationInstanceTaskLogsInput";
import { DescribeReplicationInstanceTaskLogsOutput } from "./types/DescribeReplicationInstanceTaskLogsOutput";
import { DescribeReplicationInstancesInput } from "./types/DescribeReplicationInstancesInput";
import { DescribeReplicationInstancesOutput } from "./types/DescribeReplicationInstancesOutput";
import { DescribeReplicationSubnetGroupsInput } from "./types/DescribeReplicationSubnetGroupsInput";
import { DescribeReplicationSubnetGroupsOutput } from "./types/DescribeReplicationSubnetGroupsOutput";
import { DescribeReplicationTaskAssessmentResultsInput } from "./types/DescribeReplicationTaskAssessmentResultsInput";
import { DescribeReplicationTaskAssessmentResultsOutput } from "./types/DescribeReplicationTaskAssessmentResultsOutput";
import { DescribeReplicationTasksInput } from "./types/DescribeReplicationTasksInput";
import { DescribeReplicationTasksOutput } from "./types/DescribeReplicationTasksOutput";
import { DescribeSchemasInput } from "./types/DescribeSchemasInput";
import { DescribeSchemasOutput } from "./types/DescribeSchemasOutput";
import { DescribeTableStatisticsInput } from "./types/DescribeTableStatisticsInput";
import { DescribeTableStatisticsOutput } from "./types/DescribeTableStatisticsOutput";
import { ImportCertificateInput } from "./types/ImportCertificateInput";
import { ImportCertificateOutput } from "./types/ImportCertificateOutput";
import { ListTagsForResourceInput } from "./types/ListTagsForResourceInput";
import { ListTagsForResourceOutput } from "./types/ListTagsForResourceOutput";
import { ModifyEndpointInput } from "./types/ModifyEndpointInput";
import { ModifyEndpointOutput } from "./types/ModifyEndpointOutput";
import { ModifyEventSubscriptionInput } from "./types/ModifyEventSubscriptionInput";
import { ModifyEventSubscriptionOutput } from "./types/ModifyEventSubscriptionOutput";
import { ModifyReplicationInstanceInput } from "./types/ModifyReplicationInstanceInput";
import { ModifyReplicationInstanceOutput } from "./types/ModifyReplicationInstanceOutput";
import { ModifyReplicationSubnetGroupInput } from "./types/ModifyReplicationSubnetGroupInput";
import { ModifyReplicationSubnetGroupOutput } from "./types/ModifyReplicationSubnetGroupOutput";
import { ModifyReplicationTaskInput } from "./types/ModifyReplicationTaskInput";
import { ModifyReplicationTaskOutput } from "./types/ModifyReplicationTaskOutput";
import { RebootReplicationInstanceInput } from "./types/RebootReplicationInstanceInput";
import { RebootReplicationInstanceOutput } from "./types/RebootReplicationInstanceOutput";
import { RefreshSchemasInput } from "./types/RefreshSchemasInput";
import { RefreshSchemasOutput } from "./types/RefreshSchemasOutput";
import { ReloadTablesInput } from "./types/ReloadTablesInput";
import { ReloadTablesOutput } from "./types/ReloadTablesOutput";
import { RemoveTagsFromResourceInput } from "./types/RemoveTagsFromResourceInput";
import { RemoveTagsFromResourceOutput } from "./types/RemoveTagsFromResourceOutput";
import { StartReplicationTaskAssessmentInput } from "./types/StartReplicationTaskAssessmentInput";
import { StartReplicationTaskAssessmentOutput } from "./types/StartReplicationTaskAssessmentOutput";
import { StartReplicationTaskInput } from "./types/StartReplicationTaskInput";
import { StartReplicationTaskOutput } from "./types/StartReplicationTaskOutput";
import { StopReplicationTaskInput } from "./types/StopReplicationTaskInput";
import { StopReplicationTaskOutput } from "./types/StopReplicationTaskOutput";
import { TestConnectionInput } from "./types/TestConnectionInput";
import { TestConnectionOutput } from "./types/TestConnectionOutput";
export declare class DatabaseMigrationService extends DatabaseMigrationServiceClient {
    /**
     * <p>Adds metadata tags to an AWS DMS resource, including replication instance, endpoint, security group, and migration task. These tags can also be used with cost allocation reporting to track cost associated with DMS resources, or used in a Condition statement in an IAM policy for DMS.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    addTagsToResource(args: AddTagsToResourceInput): Promise<AddTagsToResourceOutput>;
    addTagsToResource(args: AddTagsToResourceInput, cb: (err: any, data?: AddTagsToResourceOutput) => void): void;
    /**
     * <p>Applies a pending maintenance action to a resource (for example, to a replication instance).</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    applyPendingMaintenanceAction(args: ApplyPendingMaintenanceActionInput): Promise<ApplyPendingMaintenanceActionOutput>;
    applyPendingMaintenanceAction(args: ApplyPendingMaintenanceActionInput, cb: (err: any, data?: ApplyPendingMaintenanceActionOutput) => void): void;
    /**
     * <p>Creates an endpoint using the provided settings.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {KMSKeyNotAccessibleFault} <p>AWS DMS cannot access the AWS KMS key.</p>
     *   - {ResourceAlreadyExistsFault} <p>The resource you are attempting to create already exists.</p>
     *   - {ResourceQuotaExceededFault} <p>The quota for this resource quota has been exceeded.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {AccessDeniedFault} <p>AWS DMS was denied access to the endpoint. Check that the role is correctly configured.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    createEndpoint(args: CreateEndpointInput): Promise<CreateEndpointOutput>;
    createEndpoint(args: CreateEndpointInput, cb: (err: any, data?: CreateEndpointOutput) => void): void;
    /**
     * <p> Creates an AWS DMS event notification subscription. </p> <p>You can specify the type of source (<code>SourceType</code>) you want to be notified of, provide a list of AWS DMS source IDs (<code>SourceIds</code>) that triggers the events, and provide a list of event categories (<code>EventCategories</code>) for events you want to be notified of. If you specify both the <code>SourceType</code> and <code>SourceIds</code>, such as <code>SourceType = replication-instance</code> and <code>SourceIdentifier = my-replinstance</code>, you will be notified of all the replication instance events for the specified source. If you specify a <code>SourceType</code> but don't specify a <code>SourceIdentifier</code>, you receive notice of the events for that source type for all your AWS DMS sources. If you don't specify either <code>SourceType</code> nor <code>SourceIdentifier</code>, you will be notified of events generated from all AWS DMS sources belonging to your customer account.</p> <p>For more information about AWS DMS events, see <a href="https://docs.aws.amazon.com/dms/latest/userguide/CHAP_Events.html">Working with Events and Notifications</a> in the <i>AWS Database Migration Service User Guide.</i> </p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceQuotaExceededFault} <p>The quota for this resource quota has been exceeded.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {ResourceAlreadyExistsFault} <p>The resource you are attempting to create already exists.</p>
     *   - {SNSInvalidTopicFault} <p>The SNS topic is invalid.</p>
     *   - {SNSNoAuthorizationFault} <p>You are not authorized for the SNS subscription.</p>
     *   - {KMSAccessDeniedFault} <p>The ciphertext references a key that doesn't exist or that the DMS account doesn't have access to.</p>
     *   - {KMSDisabledFault} <p>The specified master key (CMK) isn't enabled.</p>
     *   - {KMSInvalidStateFault} <p>The state of the specified AWS KMS resource isn't valid for this request.</p>
     *   - {KMSNotFoundFault} <p>The specified AWS KMS entity or resource can't be found.</p>
     *   - {KMSThrottlingFault} <p>This request triggered AWS KMS request throttling.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    createEventSubscription(args: CreateEventSubscriptionInput): Promise<CreateEventSubscriptionOutput>;
    createEventSubscription(args: CreateEventSubscriptionInput, cb: (err: any, data?: CreateEventSubscriptionOutput) => void): void;
    /**
     * <p>Creates the replication instance using the specified parameters.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {AccessDeniedFault} <p>AWS DMS was denied access to the endpoint. Check that the role is correctly configured.</p>
     *   - {ResourceAlreadyExistsFault} <p>The resource you are attempting to create already exists.</p>
     *   - {InsufficientResourceCapacityFault} <p>There are not enough resources allocated to the database migration.</p>
     *   - {ResourceQuotaExceededFault} <p>The quota for this resource quota has been exceeded.</p>
     *   - {StorageQuotaExceededFault} <p>The storage quota has been exceeded.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {ReplicationSubnetGroupDoesNotCoverEnoughAZs} <p>The replication subnet group does not cover enough Availability Zones (AZs). Edit the replication subnet group and add more AZs.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {InvalidSubnet} <p>The subnet provided is invalid.</p>
     *   - {KMSKeyNotAccessibleFault} <p>AWS DMS cannot access the AWS KMS key.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    createReplicationInstance(args: CreateReplicationInstanceInput): Promise<CreateReplicationInstanceOutput>;
    createReplicationInstance(args: CreateReplicationInstanceInput, cb: (err: any, data?: CreateReplicationInstanceOutput) => void): void;
    /**
     * <p>Creates a replication subnet group given a list of the subnet IDs in a VPC.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {AccessDeniedFault} <p>AWS DMS was denied access to the endpoint. Check that the role is correctly configured.</p>
     *   - {ResourceAlreadyExistsFault} <p>The resource you are attempting to create already exists.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {ResourceQuotaExceededFault} <p>The quota for this resource quota has been exceeded.</p>
     *   - {ReplicationSubnetGroupDoesNotCoverEnoughAZs} <p>The replication subnet group does not cover enough Availability Zones (AZs). Edit the replication subnet group and add more AZs.</p>
     *   - {InvalidSubnet} <p>The subnet provided is invalid.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    createReplicationSubnetGroup(args: CreateReplicationSubnetGroupInput): Promise<CreateReplicationSubnetGroupOutput>;
    createReplicationSubnetGroup(args: CreateReplicationSubnetGroupInput, cb: (err: any, data?: CreateReplicationSubnetGroupOutput) => void): void;
    /**
     * <p>Creates a replication task using the specified parameters.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {AccessDeniedFault} <p>AWS DMS was denied access to the endpoint. Check that the role is correctly configured.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {ResourceAlreadyExistsFault} <p>The resource you are attempting to create already exists.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {KMSKeyNotAccessibleFault} <p>AWS DMS cannot access the AWS KMS key.</p>
     *   - {ResourceQuotaExceededFault} <p>The quota for this resource quota has been exceeded.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    createReplicationTask(args: CreateReplicationTaskInput): Promise<CreateReplicationTaskOutput>;
    createReplicationTask(args: CreateReplicationTaskInput, cb: (err: any, data?: CreateReplicationTaskOutput) => void): void;
    /**
     * <p>Deletes the specified certificate. </p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    deleteCertificate(args: DeleteCertificateInput): Promise<DeleteCertificateOutput>;
    deleteCertificate(args: DeleteCertificateInput, cb: (err: any, data?: DeleteCertificateOutput) => void): void;
    /**
     * <p>Deletes the specified endpoint.</p> <note> <p>All tasks associated with the endpoint must be deleted before you can delete the endpoint.</p> </note> <p/>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    deleteEndpoint(args: DeleteEndpointInput): Promise<DeleteEndpointOutput>;
    deleteEndpoint(args: DeleteEndpointInput, cb: (err: any, data?: DeleteEndpointOutput) => void): void;
    /**
     * <p> Deletes an AWS DMS event subscription. </p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    deleteEventSubscription(args: DeleteEventSubscriptionInput): Promise<DeleteEventSubscriptionOutput>;
    deleteEventSubscription(args: DeleteEventSubscriptionInput, cb: (err: any, data?: DeleteEventSubscriptionOutput) => void): void;
    /**
     * <p>Deletes the specified replication instance.</p> <note> <p>You must delete any migration tasks that are associated with the replication instance before you can delete it.</p> </note> <p/>
     *
     * This operation may fail with one of the following errors:
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    deleteReplicationInstance(args: DeleteReplicationInstanceInput): Promise<DeleteReplicationInstanceOutput>;
    deleteReplicationInstance(args: DeleteReplicationInstanceInput, cb: (err: any, data?: DeleteReplicationInstanceOutput) => void): void;
    /**
     * <p>Deletes a subnet group.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    deleteReplicationSubnetGroup(args: DeleteReplicationSubnetGroupInput): Promise<DeleteReplicationSubnetGroupOutput>;
    deleteReplicationSubnetGroup(args: DeleteReplicationSubnetGroupInput, cb: (err: any, data?: DeleteReplicationSubnetGroupOutput) => void): void;
    /**
     * <p>Deletes the specified replication task.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    deleteReplicationTask(args: DeleteReplicationTaskInput): Promise<DeleteReplicationTaskOutput>;
    deleteReplicationTask(args: DeleteReplicationTaskInput, cb: (err: any, data?: DeleteReplicationTaskOutput) => void): void;
    /**
     * <p>Lists all of the AWS DMS attributes for a customer account. These attributes include AWS DMS quotas for the account and a unique account identifier in a particular DMS region. DMS quotas include a list of resource quotas supported by the account, such as the number of replication instances allowed. The description for each resource quota, includes the quota name, current usage toward that quota, and the quota's maximum value. DMS uses the unique account identifier to name each artifact used by DMS in the given region.</p> <p>This command does not take any parameters.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeAccountAttributes(args: DescribeAccountAttributesInput): Promise<DescribeAccountAttributesOutput>;
    describeAccountAttributes(args: DescribeAccountAttributesInput, cb: (err: any, data?: DescribeAccountAttributesOutput) => void): void;
    /**
     * <p>Provides a description of the certificate.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeCertificates(args: DescribeCertificatesInput): Promise<DescribeCertificatesOutput>;
    describeCertificates(args: DescribeCertificatesInput, cb: (err: any, data?: DescribeCertificatesOutput) => void): void;
    /**
     * <p>Describes the status of the connections that have been made between the replication instance and an endpoint. Connections are created when you test an endpoint.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeConnections(args: DescribeConnectionsInput): Promise<DescribeConnectionsOutput>;
    describeConnections(args: DescribeConnectionsInput, cb: (err: any, data?: DescribeConnectionsOutput) => void): void;
    /**
     * <p>Returns information about the type of endpoints available.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeEndpointTypes(args: DescribeEndpointTypesInput): Promise<DescribeEndpointTypesOutput>;
    describeEndpointTypes(args: DescribeEndpointTypesInput, cb: (err: any, data?: DescribeEndpointTypesOutput) => void): void;
    /**
     * <p>Returns information about the endpoints for your account in the current region.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeEndpoints(args: DescribeEndpointsInput): Promise<DescribeEndpointsOutput>;
    describeEndpoints(args: DescribeEndpointsInput, cb: (err: any, data?: DescribeEndpointsOutput) => void): void;
    /**
     * <p>Lists categories for all event source types, or, if specified, for a specified source type. You can see a list of the event categories and source types in <a href="https://docs.aws.amazon.com/dms/latest/userguide/CHAP_Events.html">Working with Events and Notifications</a> in the <i>AWS Database Migration Service User Guide.</i> </p>
     *
     * This operation may fail with one of the following errors:
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeEventCategories(args: DescribeEventCategoriesInput): Promise<DescribeEventCategoriesOutput>;
    describeEventCategories(args: DescribeEventCategoriesInput, cb: (err: any, data?: DescribeEventCategoriesOutput) => void): void;
    /**
     * <p>Lists all the event subscriptions for a customer account. The description of a subscription includes <code>SubscriptionName</code>, <code>SNSTopicARN</code>, <code>CustomerID</code>, <code>SourceType</code>, <code>SourceID</code>, <code>CreationTime</code>, and <code>Status</code>. </p> <p>If you specify <code>SubscriptionName</code>, this action lists the description for that subscription.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeEventSubscriptions(args: DescribeEventSubscriptionsInput): Promise<DescribeEventSubscriptionsOutput>;
    describeEventSubscriptions(args: DescribeEventSubscriptionsInput, cb: (err: any, data?: DescribeEventSubscriptionsOutput) => void): void;
    /**
     * <p> Lists events for a given source identifier and source type. You can also specify a start and end time. For more information on AWS DMS events, see <a href="https://docs.aws.amazon.com/dms/latest/userguide/CHAP_Events.html">Working with Events and Notifications</a> in the <i>AWS Database Migration User Guide.</i> </p>
     *
     * This operation may fail with one of the following errors:
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeEvents(args: DescribeEventsInput): Promise<DescribeEventsOutput>;
    describeEvents(args: DescribeEventsInput, cb: (err: any, data?: DescribeEventsOutput) => void): void;
    /**
     * <p>Returns information about the replication instance types that can be created in the specified region.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeOrderableReplicationInstances(args: DescribeOrderableReplicationInstancesInput): Promise<DescribeOrderableReplicationInstancesOutput>;
    describeOrderableReplicationInstances(args: DescribeOrderableReplicationInstancesInput, cb: (err: any, data?: DescribeOrderableReplicationInstancesOutput) => void): void;
    /**
     * <p>For internal use only</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describePendingMaintenanceActions(args: DescribePendingMaintenanceActionsInput): Promise<DescribePendingMaintenanceActionsOutput>;
    describePendingMaintenanceActions(args: DescribePendingMaintenanceActionsInput, cb: (err: any, data?: DescribePendingMaintenanceActionsOutput) => void): void;
    /**
     * <p>Returns the status of the RefreshSchemas operation.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeRefreshSchemasStatus(args: DescribeRefreshSchemasStatusInput): Promise<DescribeRefreshSchemasStatusOutput>;
    describeRefreshSchemasStatus(args: DescribeRefreshSchemasStatusInput, cb: (err: any, data?: DescribeRefreshSchemasStatusOutput) => void): void;
    /**
     * <p>Returns information about the task logs for the specified task.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeReplicationInstanceTaskLogs(args: DescribeReplicationInstanceTaskLogsInput): Promise<DescribeReplicationInstanceTaskLogsOutput>;
    describeReplicationInstanceTaskLogs(args: DescribeReplicationInstanceTaskLogsInput, cb: (err: any, data?: DescribeReplicationInstanceTaskLogsOutput) => void): void;
    /**
     * <p>Returns information about replication instances for your account in the current region.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeReplicationInstances(args: DescribeReplicationInstancesInput): Promise<DescribeReplicationInstancesOutput>;
    describeReplicationInstances(args: DescribeReplicationInstancesInput, cb: (err: any, data?: DescribeReplicationInstancesOutput) => void): void;
    /**
     * <p>Returns information about the replication subnet groups.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeReplicationSubnetGroups(args: DescribeReplicationSubnetGroupsInput): Promise<DescribeReplicationSubnetGroupsOutput>;
    describeReplicationSubnetGroups(args: DescribeReplicationSubnetGroupsInput, cb: (err: any, data?: DescribeReplicationSubnetGroupsOutput) => void): void;
    /**
     * <p>Returns the task assessment results from Amazon S3. This action always returns the latest results.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeReplicationTaskAssessmentResults(args: DescribeReplicationTaskAssessmentResultsInput): Promise<DescribeReplicationTaskAssessmentResultsOutput>;
    describeReplicationTaskAssessmentResults(args: DescribeReplicationTaskAssessmentResultsInput, cb: (err: any, data?: DescribeReplicationTaskAssessmentResultsOutput) => void): void;
    /**
     * <p>Returns information about replication tasks for your account in the current region.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeReplicationTasks(args: DescribeReplicationTasksInput): Promise<DescribeReplicationTasksOutput>;
    describeReplicationTasks(args: DescribeReplicationTasksInput, cb: (err: any, data?: DescribeReplicationTasksOutput) => void): void;
    /**
     * <p>Returns information about the schema for the specified endpoint.</p> <p/>
     *
     * This operation may fail with one of the following errors:
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeSchemas(args: DescribeSchemasInput): Promise<DescribeSchemasOutput>;
    describeSchemas(args: DescribeSchemasInput, cb: (err: any, data?: DescribeSchemasOutput) => void): void;
    /**
     * <p>Returns table statistics on the database migration task, including table name, rows inserted, rows updated, and rows deleted.</p> <p>Note that the "last updated" column the DMS console only indicates the time that AWS DMS last updated the table statistics record for a table. It does not indicate the time of the last update to the table.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    describeTableStatistics(args: DescribeTableStatisticsInput): Promise<DescribeTableStatisticsOutput>;
    describeTableStatistics(args: DescribeTableStatisticsInput, cb: (err: any, data?: DescribeTableStatisticsOutput) => void): void;
    /**
     * <p>Uploads the specified certificate.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceAlreadyExistsFault} <p>The resource you are attempting to create already exists.</p>
     *   - {InvalidCertificateFault} <p>The certificate was not valid.</p>
     *   - {ResourceQuotaExceededFault} <p>The quota for this resource quota has been exceeded.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    importCertificate(args: ImportCertificateInput): Promise<ImportCertificateOutput>;
    importCertificate(args: ImportCertificateInput, cb: (err: any, data?: ImportCertificateOutput) => void): void;
    /**
     * <p>Lists all tags for an AWS DMS resource.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    listTagsForResource(args: ListTagsForResourceInput): Promise<ListTagsForResourceOutput>;
    listTagsForResource(args: ListTagsForResourceInput, cb: (err: any, data?: ListTagsForResourceOutput) => void): void;
    /**
     * <p>Modifies the specified endpoint.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {ResourceAlreadyExistsFault} <p>The resource you are attempting to create already exists.</p>
     *   - {KMSKeyNotAccessibleFault} <p>AWS DMS cannot access the AWS KMS key.</p>
     *   - {AccessDeniedFault} <p>AWS DMS was denied access to the endpoint. Check that the role is correctly configured.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    modifyEndpoint(args: ModifyEndpointInput): Promise<ModifyEndpointOutput>;
    modifyEndpoint(args: ModifyEndpointInput, cb: (err: any, data?: ModifyEndpointOutput) => void): void;
    /**
     * <p>Modifies an existing AWS DMS event notification subscription. </p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceQuotaExceededFault} <p>The quota for this resource quota has been exceeded.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {SNSInvalidTopicFault} <p>The SNS topic is invalid.</p>
     *   - {SNSNoAuthorizationFault} <p>You are not authorized for the SNS subscription.</p>
     *   - {KMSAccessDeniedFault} <p>The ciphertext references a key that doesn't exist or that the DMS account doesn't have access to.</p>
     *   - {KMSDisabledFault} <p>The specified master key (CMK) isn't enabled.</p>
     *   - {KMSInvalidStateFault} <p>The state of the specified AWS KMS resource isn't valid for this request.</p>
     *   - {KMSNotFoundFault} <p>The specified AWS KMS entity or resource can't be found.</p>
     *   - {KMSThrottlingFault} <p>This request triggered AWS KMS request throttling.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    modifyEventSubscription(args: ModifyEventSubscriptionInput): Promise<ModifyEventSubscriptionOutput>;
    modifyEventSubscription(args: ModifyEventSubscriptionInput, cb: (err: any, data?: ModifyEventSubscriptionOutput) => void): void;
    /**
     * <p>Modifies the replication instance to apply new settings. You can change one or more parameters by specifying these parameters and the new values in the request.</p> <p>Some settings are applied during the maintenance window.</p> <p/>
     *
     * This operation may fail with one of the following errors:
     *   - {AccessDeniedFault} <p>AWS DMS was denied access to the endpoint. Check that the role is correctly configured.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {ResourceAlreadyExistsFault} <p>The resource you are attempting to create already exists.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {InsufficientResourceCapacityFault} <p>There are not enough resources allocated to the database migration.</p>
     *   - {StorageQuotaExceededFault} <p>The storage quota has been exceeded.</p>
     *   - {UpgradeDependencyFailureFault} <p>An upgrade dependency is preventing the database migration.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    modifyReplicationInstance(args: ModifyReplicationInstanceInput): Promise<ModifyReplicationInstanceOutput>;
    modifyReplicationInstance(args: ModifyReplicationInstanceInput, cb: (err: any, data?: ModifyReplicationInstanceOutput) => void): void;
    /**
     * <p>Modifies the settings for the specified replication subnet group.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {AccessDeniedFault} <p>AWS DMS was denied access to the endpoint. Check that the role is correctly configured.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {ResourceQuotaExceededFault} <p>The quota for this resource quota has been exceeded.</p>
     *   - {SubnetAlreadyInUse} <p>The specified subnet is already in use.</p>
     *   - {ReplicationSubnetGroupDoesNotCoverEnoughAZs} <p>The replication subnet group does not cover enough Availability Zones (AZs). Edit the replication subnet group and add more AZs.</p>
     *   - {InvalidSubnet} <p>The subnet provided is invalid.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    modifyReplicationSubnetGroup(args: ModifyReplicationSubnetGroupInput): Promise<ModifyReplicationSubnetGroupOutput>;
    modifyReplicationSubnetGroup(args: ModifyReplicationSubnetGroupInput, cb: (err: any, data?: ModifyReplicationSubnetGroupOutput) => void): void;
    /**
     * <p>Modifies the specified replication task.</p> <p>You can't modify the task endpoints. The task must be stopped before you can modify it. </p> <p>For more information about AWS DMS tasks, see <a href="https://docs.aws.amazon.com/dms/latest/userguide/CHAP_Tasks.html">Working with Migration Tasks</a> in the <i>AWS Database Migration Service User Guide</i>.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {ResourceAlreadyExistsFault} <p>The resource you are attempting to create already exists.</p>
     *   - {KMSKeyNotAccessibleFault} <p>AWS DMS cannot access the AWS KMS key.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    modifyReplicationTask(args: ModifyReplicationTaskInput): Promise<ModifyReplicationTaskOutput>;
    modifyReplicationTask(args: ModifyReplicationTaskInput, cb: (err: any, data?: ModifyReplicationTaskOutput) => void): void;
    /**
     * <p>Reboots a replication instance. Rebooting results in a momentary outage, until the replication instance becomes available again.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    rebootReplicationInstance(args: RebootReplicationInstanceInput): Promise<RebootReplicationInstanceOutput>;
    rebootReplicationInstance(args: RebootReplicationInstanceInput, cb: (err: any, data?: RebootReplicationInstanceOutput) => void): void;
    /**
     * <p>Populates the schema for the specified endpoint. This is an asynchronous operation and can take several minutes. You can check the status of this operation by calling the DescribeRefreshSchemasStatus operation.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {KMSKeyNotAccessibleFault} <p>AWS DMS cannot access the AWS KMS key.</p>
     *   - {ResourceQuotaExceededFault} <p>The quota for this resource quota has been exceeded.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    refreshSchemas(args: RefreshSchemasInput): Promise<RefreshSchemasOutput>;
    refreshSchemas(args: RefreshSchemasInput, cb: (err: any, data?: RefreshSchemasOutput) => void): void;
    /**
     * <p>Reloads the target database table with the source data. </p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    reloadTables(args: ReloadTablesInput): Promise<ReloadTablesOutput>;
    reloadTables(args: ReloadTablesInput, cb: (err: any, data?: ReloadTablesOutput) => void): void;
    /**
     * <p>Removes metadata tags from a DMS resource.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    removeTagsFromResource(args: RemoveTagsFromResourceInput): Promise<RemoveTagsFromResourceOutput>;
    removeTagsFromResource(args: RemoveTagsFromResourceInput, cb: (err: any, data?: RemoveTagsFromResourceOutput) => void): void;
    /**
     * <p>Starts the replication task.</p> <p>For more information about AWS DMS tasks, see <a href="https://docs.aws.amazon.com/dms/latest/userguide/CHAP_Tasks.html">Working with Migration Tasks </a> in the <i>AWS Database Migration Service User Guide.</i> </p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {AccessDeniedFault} <p>AWS DMS was denied access to the endpoint. Check that the role is correctly configured.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    startReplicationTask(args: StartReplicationTaskInput): Promise<StartReplicationTaskOutput>;
    startReplicationTask(args: StartReplicationTaskInput, cb: (err: any, data?: StartReplicationTaskOutput) => void): void;
    /**
     * <p> Starts the replication task assessment for unsupported data types in the source database. </p>
     *
     * This operation may fail with one of the following errors:
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    startReplicationTaskAssessment(args: StartReplicationTaskAssessmentInput): Promise<StartReplicationTaskAssessmentOutput>;
    startReplicationTaskAssessment(args: StartReplicationTaskAssessmentInput, cb: (err: any, data?: StartReplicationTaskAssessmentOutput) => void): void;
    /**
     * <p>Stops the replication task.</p> <p/>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    stopReplicationTask(args: StopReplicationTaskInput): Promise<StopReplicationTaskOutput>;
    stopReplicationTask(args: StopReplicationTaskInput, cb: (err: any, data?: StopReplicationTaskOutput) => void): void;
    /**
     * <p>Tests the connection between the replication instance and the endpoint.</p>
     *
     * This operation may fail with one of the following errors:
     *   - {ResourceNotFoundFault} <p>The resource could not be found.</p>
     *   - {InvalidResourceStateFault} <p>The resource is in a state that prevents it from being used for database migration.</p>
     *   - {KMSKeyNotAccessibleFault} <p>AWS DMS cannot access the AWS KMS key.</p>
     *   - {ResourceQuotaExceededFault} <p>The quota for this resource quota has been exceeded.</p>
     *   - {Error} An error originating from the SDK or customizations rather than the service
     */
    testConnection(args: TestConnectionInput): Promise<TestConnectionOutput>;
    testConnection(args: TestConnectionInput, cb: (err: any, data?: TestConnectionOutput) => void): void;
}
