"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var DescribeReplicationInstanceTaskLogs_1 = require("../model/operations/DescribeReplicationInstanceTaskLogs");
var DescribeReplicationInstanceTaskLogsCommand = /** @class */ (function () {
    function DescribeReplicationInstanceTaskLogsCommand(input) {
        this.input = input;
        this.model = DescribeReplicationInstanceTaskLogs_1.DescribeReplicationInstanceTaskLogs;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    DescribeReplicationInstanceTaskLogsCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return DescribeReplicationInstanceTaskLogsCommand;
}());
exports.DescribeReplicationInstanceTaskLogsCommand = DescribeReplicationInstanceTaskLogsCommand;
//# sourceMappingURL=DescribeReplicationInstanceTaskLogsCommand.js.map