"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var DescribeSchemas_1 = require("../model/operations/DescribeSchemas");
var DescribeSchemasCommand = /** @class */ (function () {
    function DescribeSchemasCommand(input) {
        this.input = input;
        this.model = DescribeSchemas_1.DescribeSchemas;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    DescribeSchemasCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return DescribeSchemasCommand;
}());
exports.DescribeSchemasCommand = DescribeSchemasCommand;
//# sourceMappingURL=DescribeSchemasCommand.js.map