"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var __aws_sdk_middleware_stack = require("@aws-sdk/middleware-stack");
var RebootReplicationInstance_1 = require("../model/operations/RebootReplicationInstance");
var RebootReplicationInstanceCommand = /** @class */ (function () {
    function RebootReplicationInstanceCommand(input) {
        this.input = input;
        this.model = RebootReplicationInstance_1.RebootReplicationInstance;
        this.middlewareStack = new __aws_sdk_middleware_stack.MiddlewareStack();
    }
    RebootReplicationInstanceCommand.prototype.resolveMiddleware = function (clientStack, configuration) {
        var handler = configuration.handler;
        var stack = clientStack.concat(this.middlewareStack);
        var handlerExecutionContext = {
            logger: {},
            model: this.model
        };
        return stack.resolve(handler(handlerExecutionContext), handlerExecutionContext);
    };
    return RebootReplicationInstanceCommand;
}());
exports.RebootReplicationInstanceCommand = RebootReplicationInstanceCommand;
//# sourceMappingURL=RebootReplicationInstanceCommand.js.map