"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CreateReplicationSubnetGroupInput_1 = require("../shapes/CreateReplicationSubnetGroupInput");
var CreateReplicationSubnetGroupOutput_1 = require("../shapes/CreateReplicationSubnetGroupOutput");
var AccessDeniedFault_1 = require("../shapes/AccessDeniedFault");
var ResourceAlreadyExistsFault_1 = require("../shapes/ResourceAlreadyExistsFault");
var ResourceNotFoundFault_1 = require("../shapes/ResourceNotFoundFault");
var ResourceQuotaExceededFault_1 = require("../shapes/ResourceQuotaExceededFault");
var ReplicationSubnetGroupDoesNotCoverEnoughAZs_1 = require("../shapes/ReplicationSubnetGroupDoesNotCoverEnoughAZs");
var InvalidSubnet_1 = require("../shapes/InvalidSubnet");
var ServiceMetadata_1 = require("../ServiceMetadata");
exports.CreateReplicationSubnetGroup = {
    metadata: ServiceMetadata_1.ServiceMetadata,
    name: "CreateReplicationSubnetGroup",
    http: {
        method: "POST",
        requestUri: "/"
    },
    input: {
        shape: CreateReplicationSubnetGroupInput_1.CreateReplicationSubnetGroupInput
    },
    output: {
        shape: CreateReplicationSubnetGroupOutput_1.CreateReplicationSubnetGroupOutput
    },
    errors: [
        {
            shape: AccessDeniedFault_1.AccessDeniedFault
        },
        {
            shape: ResourceAlreadyExistsFault_1.ResourceAlreadyExistsFault
        },
        {
            shape: ResourceNotFoundFault_1.ResourceNotFoundFault
        },
        {
            shape: ResourceQuotaExceededFault_1.ResourceQuotaExceededFault
        },
        {
            shape: ReplicationSubnetGroupDoesNotCoverEnoughAZs_1.ReplicationSubnetGroupDoesNotCoverEnoughAZs
        },
        {
            shape: InvalidSubnet_1.InvalidSubnet
        }
    ]
};
//# sourceMappingURL=CreateReplicationSubnetGroup.js.map